import 'package:flutter/material.dart';
import 'package:parse_text/constants.dart';
import 'package:parse_text/parse_text.dart';
import 'package:parse_text/recognizer.dart';
import 'Stack.dart';

List<String> list;
List<String> msg;
int size = 0;
stack<TAGS> tack = stack<TAGS>();
String normalText = "";
String normalTemp = "";
String styledText = "";

ParseText localObj;

List<TextSpan> resSpan = [];

List<TextSpan> extractor(String text, ParseText obj) {
  normalTemp = "";
  normalText = "";
  styledText = "";
  size = 0;
  msg = [];
  list = [];
  localObj = obj;
  int tLen = 0;
  list = text.split(regSpliter);
  for (String s in list) {
    bool flag = true;
    String tem = s;

    if ((tLen = isBold(s)) > 0) {
      tem = (flag ? s : tem).replaceAll("*", "");
      if (tLen == 1) {
        tack.push(TAGS.BOLD);
      } else {
        tack.push(TAGS.BOLD);
        tack.push(TAGS.BOLD);
      }
      flag = false;
      addNormalTextSpan(false);
    }
    if ((tLen = isItalic(s)) > 0) {
      tem = (flag ? s : tem).replaceAll("_", "");
      if (tLen == 1) {
        tack.push(TAGS.ITALIC);
      } else {
        tack.push(TAGS.ITALIC);
        tack.push(TAGS.ITALIC);
      }
      flag = false;
      addNormalTextSpan(false);
    }
    if ((tLen = isCross(s)) > 0) {
      tem = (flag ? s : tem).replaceAll("~", "");
      if (tLen == 1) {
        tack.push(TAGS.CROSS);
      } else {
        tack.push(TAGS.CROSS);
        tack.push(TAGS.CROSS);
      }
      flag = false;
    }
    if (isUrl(flag ? s : tem)) {
      tack.push(TAGS.LINK);
      tack.push(TAGS.LINK);
      tem = flag ? s : tem;
      flag = false;
    }
    if (isMob(flag ? s : tem)) {
      tack.push(TAGS.MOBILE);
      tack.push(TAGS.MOBILE);
      tem = flag ? s : tem;
      flag = false;
    }
    if (isEmail(flag ? s : tem)) {
      tack.push(TAGS.EMAIL);
      tack.push(TAGS.EMAIL);
      tem = flag ? s : tem;
      flag = false;
    }

    normalTemp += s;
    if (flag && tack.isEmpty) {
      addNormalText(tem);
    }
    if (!flag) addNormalTextSpan(false);
    if (!tack.isEmpty) {
      addStyledText(tem);
    }
    addStyledTextSpan();
  }
  addNormalTextSpan(true);
  return resSpan;
}

//adds current word noramlText
void addNormalText(String s) {
  normalText += s;
}

//adds current word styledText
void addStyledText(String s) {
  styledText += s ?? '';
}

//adds normalTestSpan and flush normalText
void addNormalTextSpan(bool last) {
  if (normalText.isNotEmpty || (normalTemp.isNotEmpty && last)) {
    final span = TextSpan(
      text: last ? normalTemp : normalText,
      style: TextStyle(
          color: localObj.color,
          fontWeight: localObj.wt,
          fontSize: localObj.size,
          fontStyle: localObj.style),
    );
    resSpan.add(span);
    normalText = "";
  }
}

//adds StyledTestSpan and flush styledText
void addStyledTextSpan() {
  int flag = 0;
  if (styledText.isEmpty) return;
  int type = 0;
  TextStyle style = TextStyle();
  while (tack.count(tack.top()) > 1) {
    flag = 1;
    TAGS tag = tack.top();
    switch (tag) {
      case TAGS.BOLD:
        style = style.copyWith(
          fontWeight: FontWeight.bold,
          fontSize: localObj.boldSize ?? localObj.size,
          color: type != 0 ? null : localObj.boldColor,
        );
        break;
      case TAGS.ITALIC:
        style = style.copyWith(
          fontSize: localObj.italicSize ?? localObj.size,
          fontStyle: FontStyle.italic,
          color: type != 0 ? null : localObj.italicColor,
        );
        break;
      case TAGS.CROSS:
        style = style.copyWith(
          decoration: TextDecoration.lineThrough,
          fontSize: localObj.crossSize ?? localObj.size,
          color: type != 0 ? null : localObj.crossColor,
        );
        break;
      case TAGS.LINK:
        style = style.copyWith(
          fontWeight: localObj.urlFW,
          fontSize: localObj.urlSize ?? localObj.size,
          fontStyle: localObj.urlStyle,
          color: localObj.urlColor,
        );
        type = 1;
        break;
      case TAGS.MOBILE:
        style = style.copyWith(
          fontWeight: localObj.mobFW,
          fontSize: localObj.mobSize ?? localObj.size,
          fontStyle: localObj.mobStyle,
          color: localObj.mobColor,
        );
        type = 2;
        break;
      case TAGS.EMAIL:
        style = style.copyWith(
          fontWeight: localObj.emailFW,
          fontSize: localObj.emailSize ?? localObj.size,
          fontStyle: localObj.emailStyle,
          color: localObj.emailColor,
        );
        type = 3;
        break;
    }
    tack.removeAll(tag);
  }
  if (flag == 1) {
    TextSpan span;
    span = TextSpan(
      text: styledText,
      recognizer: type > 0 ? launchCustom(styledText, type) : null,
      style: style,
    );
    resSpan.add(span);
    styledText = "";
    normalTemp = "";
  }
}
