library parse_text;

import 'package:flutter/material.dart';
import 'package:parse_text/extractor.dart';

class ParseText extends StatelessWidget {
  ParseText({
    @required this.size,
    @required this.text,
    this.color: const Color(0xFF424242),
    this.wt: FontWeight.normal,
    this.align,
    this.maxLine,
    this.style: FontStyle.normal,
    //email
    this.emailColor: Colors.blue,
    this.emailFW: FontWeight.w600,
    this.emailSize,
    this.emailStyle: FontStyle.normal,
    //mobile
    this.mobColor: Colors.blue,
    this.mobFW: FontWeight.w600,
    this.mobSize,
    this.mobStyle: FontStyle.normal,
    //url
    this.urlColor: Colors.blue,
    this.urlFW: FontWeight.w600,
    this.urlSize,
    this.urlStyle: FontStyle.normal,
    //bold
    this.boldColor: const Color(0xFF424242),
    this.boldSize,
    //italic
    this.italicColor: const Color(0xFF424242),
    this.italicSize,
    //cross
    this.crossColor: const Color(0xFF424242),
    this.crossSize,
  });

  /// Set size of normal text
  final double size;

  /// Set input text that would be parsed
  final String text;

  /// Set Color of normal text
  final Color color;

  /// Set FontWeight of normal text
  final FontWeight wt;

  /// Set FontStyle of normal text
  final FontStyle style;

  /// Set TextAlign of text
  final TextAlign align;

  /// Set maxLine of text
  final int maxLine;

  /// Set Color of detected email text
  final Color emailColor;

  /// Set FontWeight of detected email text
  final FontWeight emailFW;

  /// Set Size of detected email text
  final double emailSize;

  /// Set FontStyle of detected email text
  final FontStyle emailStyle;

  /// Set Color of detected Mobile text
  final Color mobColor;

  /// Set FontWeight of detected email text
  final FontWeight mobFW;

  /// Set Size of detected email text
  final double mobSize;

  /// Set FontStyle of detected email text
  final FontStyle mobStyle;

  /// Set Color of detected url text
  final Color urlColor;

  /// Set FontWeight of detected url text
  final FontWeight urlFW;

  /// Set Size of detected url text
  final double urlSize;

  /// Set FontStyle of detected url text
  final FontStyle urlStyle;

  /// Set Color of detected Bold text
  final Color boldColor;

  /// Set Size of detected Bold text
  final double boldSize;

  /// Set Color of detected Italic text
  final Color italicColor;

  /// Set Size of detected Italic text
  final double italicSize;

  /// Set Color of detected Crossed text
  final Color crossColor;

  /// Set Size of detected Crossed text
  final double crossSize;

  @override
  Widget build(BuildContext context) {
    List<TextSpan> inputList = extractor(text ?? "", this);
    return Text.rich(
      TextSpan(children: inputList),
      textAlign: align,
      maxLines: maxLine,
    );
  }
}
